package Time2Str;

BEGIN{
	(%Time2Str::DEFAULT,%Time2Str::SINONIM)=();
	@Time2Str::MONTHN=
		qw'           ';
	@Time2Str::MONTHNP=
		qw'           ';
	@Time2Str::WDAYN=qw'      ';
	
	@Time2Str::keys=qw'a A d D F g G h H i j l L m M n r s U Y y z w W';
	@Time2Str::DEFAULT{@Time2Str::keys}=(
					qw'%2s %2s %02d %3s %s %d %d %02d %02d %02d %d %s %1b %02d %3s %d',
					'%3s, %02d %3s %04d %02d:%02d:%02d',
					qw'%02d %010d %04d %02d %3d %d %s'
				);
	@Time2Str::SINONIM{@Time2Str::keys}=(
		sub{my$self=shift;
			+$self->{hash}->{a}||=sprintf$Time2Str::DEFAULT{a},$self->{list}->{hour}>12?'pm':'am'
		},
		sub{my$self=shift;
			+$self->{hash}->{A}||=sprintf$Time2Str::DEFAULT{A},$self->{list}->{hour}>12?'PM':'AM'},
		sub{my$self=shift;
			+$self->{hash}->{d}||=sprintf$Time2Str::DEFAULT{d},$self->{list}->{mday}},
		sub{my$self=shift;
			+$self->{hash}->{D}||=sprintf$Time2Str::DEFAULT{D},
			substr$Time2Str::WDAYN[$self->{list}->{wday}-1],0,3},
		sub{my$self=shift;
			+$self->{hash}->{F}||=sprintf$Time2Str::DEFAULT{F},
			$Time2Str::MONTHN[$self->{list}->{mon}-1]},
		sub{my$self=shift;
			+$self->{hash}->{g}||=sprintf$Time2Str::DEFAULT{g},
				$self->{list}->{hour}>12?$self->{list}->{hour}-12:$self->{list}->{hour}},
		sub{my$self=shift;
			+$self->{hash}->{G}||=sprintf$Time2Str::DEFAULT{G},$self->{list}->{hour}},
		sub{my$self=shift;
			+$self->{hash}->{h}||=sprintf$Time2Str::DEFAULT{h},$self->{list}->{hour}},
		sub{my$self=shift;
			+$self->{hash}->{H}||=sprintf$Time2Str::DEFAULT{H},$self->{list}->{hour}},
		sub{my$self=shift;
			+$self->{hash}->{i}||=sprintf$Time2Str::DEFAULT{i},$self->{list}->{min}},
		sub{my$self=shift;
			+$self->{hash}->{j}||=sprintf$Time2Str::DEFAULT{j},$self->{list}->{mday}},
		sub{my$self=shift;
			+$self->{hash}->{l}||=sprintf$Time2Str::DEFAULT{l},
			$Time2Str::WDAYN[$self->{list}->{wday}-1]},
		sub{my$self=shift;
			+$self->{hash}->{L}||=sprintf$Time2Str::DEFAULT{L},$self->{list}->{isdst}},
		sub{my$self=shift;
			+$self->{hash}->{m}||=sprintf$Time2Str::DEFAULT{m},$self->{list}->{mon}},
		sub{my$self=shift;
			+$self->{hash}->{M}||=sprintf$Time2Str::DEFAULT{M},
				substr$Time2Str::MONTHN[$self->{list}->{mon}-1],0,3},
		sub{my$self=shift;
			+$self->{hash}->{n}||=sprintf$Time2Str::DEFAULT{n},$self->{list}->{mon}},
		sub{my$self=shift;
			+$self->{hash}->{r}||=sprintf$Time2Str::DEFAULT{r},
											&{$Time2Str::SINONIM{D}}($self),
											&{$Time2Str::SINONIM{d}}($self),
											&{$Time2Str::SINONIM{M}}($self),
											&{$Time2Str::SINONIM{Y}}($self),
											&{$Time2Str::SINONIM{H}}($self),
											&{$Time2Str::SINONIM{i}}($self),
											&{$Time2Str::SINONIM{s}}($self)
			},
		sub{my$self=shift;
			+$self->{hash}->{s}||=sprintf$Time2Str::DEFAULT{s},$self->{list}->{sec}},
		sub{my$self=shift;
			+$self->{hash}->{U}||=sprintf$Time2Str::DEFAULT{U},$self->{list}->{time}},
		sub{my$self=shift;
			+$self->{hash}->{Y}||=sprintf$Time2Str::DEFAULT{Y},$self->{list}->{year}},
		sub{my$self=shift;
			+$self->{hash}->{y}||=sprintf$Time2Str::DEFAULT{y},substr$self->{list}->{year},-2},
		sub{my$self=shift;
			+$self->{hash}->{z}||=sprintf$Time2Str::DEFAULT{z},$self->{list}->{yday}},
		sub{my$self=shift;
			+$self->{hash}->{w}||=sprintf$Time2Str::DEFAULT{w},$self->{list}->{wday}},
		sub{my$self=shift;
			+$self->{hash}->{W}||=sprintf$Time2Str::DEFAULT{W},
					$Time2Str::MONTHNP[$self->{list}->{mon}-1]}
	);
}

sub new
{
	my%self;
	tie%self,shift,shift;
	+\%self
}

sub TIEHASH
{
	my$class=bless{list=>{},hash=>{}},shift;
	$class->STORE('time',shift);
	+$class
}

sub STORE
{
	my$self=shift;
	my$key=shift;
	my$val=shift;

	if($key eq 'time')
	{
		$self->{hash}=();
		$self->{list}->{$key}=$val||time;
		@{$self->{list}}{
							+qw'sec min hour mday mon year wday yday isdst'
						}=localtime$self->{list}->{time};
		$self->{list}->{year}+=19e+2;
		$self->{list}->{mon}++;
	}

	+$val
}

sub PARSE
{
	my$self=shift;
	my$key=shift;
	my$time=shift;

	my$ltime=$self->{list}->{time};
	$self->STORE('time',$time);
	my$res=$self->FETCH($key);
	$self->STORE('time',$ltime);

	+$res
}

sub FETCH
{
	my$self=shift;
	my$key=shift||return;

	return $self->{list}->{$key} if exists$self->{list}->{$key};
	return undef unless index$key,'_:';
	return $self->PARSE($2,$1) if $key=~/^_(\d{10})\:(.+)$/o;

	$key=~s/(\\?)(.)/
					if(!$1&&exists$Time2Str::SINONIM{$2})
					{
						+&{$Time2Str::SINONIM{$2}}($self)
					}
					else
					{
						+$2
					}
			/geos;
	+$key
}

sub FIRSTKEY
{
	my$self=shift;
	reset%{$self->{list}};
	+$self->NEXTKEY
}

sub NEXTKEY
{
	+each%{${+shift}{list}}
}

sub DESTROY
{
	+undef@{$self}{'hash','list'}
}

sub AUTOLOAD
{
	+wantarray?@_:$_[0]
}

sub sqldate2str
{
	my$date=shift;
	return sprintf'%02d %s %04d ',$3,$Time2Str::MONTHNP[$2-1],$1
												if $date=~/^(\d\d\d\d)\-(\d\d)\-(\d\d)$/o;
	+$date
}

1;